import React, { useEffect } from 'react';
import { Icon, Form } from 'rlj-design';
import FilterValue from "./FilterValue";
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/filterContent.less";
var prefixCls = "".concat(PREFIX_CLS, "-filter-content");

var FilterContent = function FilterContent(props) {
  var filterTitle = props.filterTitle,
      filterSecondTitle = props.filterSecondTitle;

  var _Form$useFormInstance = Form.useFormInstance(),
      validateFields = _Form$useFormInstance.validateFields,
      setFieldsValue = _Form$useFormInstance.setFieldsValue;

  useEffect(function () {
    setFieldsValue({
      fields: [undefined]
    });
  }, []);

  var addNewItem = function addNewItem(add) {
    validateFields().then(function () {
      add();
    }).catch(function (error) {
      console.log(error);
    });
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-title")
  }, filterTitle, /*#__PURE__*/React.createElement("span", null, filterSecondTitle)), /*#__PURE__*/React.createElement(Form.List, {
    name: "fields"
  }, function (fields, _ref) {
    var add = _ref.add,
        remove = _ref.remove;
    return /*#__PURE__*/React.createElement(React.Fragment, null, fields.map(function (item) {
      return /*#__PURE__*/React.createElement(FilterValue, {
        key: item.key,
        item: item,
        remove: remove
      });
    }), /*#__PURE__*/React.createElement(Form.Item, null, /*#__PURE__*/React.createElement("a", {
      className: "".concat(prefixCls, "-add"),
      onClick: function onClick() {
        return addNewItem(add);
      }
    }, /*#__PURE__*/React.createElement(Icon, {
      type: "add"
    }), "\u6DFB\u52A0\u7B5B\u9009\u6761\u4EF6")));
  }));
};

FilterContent.defaultProps = {
  filterTitle: '筛选',
  filterSecondTitle: '（添加多个筛选条件，可交叉选择）'
};
export default FilterContent;