var _excluded = ["filterData", "itemRender", "showSearch", "onChange"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { Fragment, useState, useMemo } from 'react';
import CustomizeSearch from "../CustomizeSearch";
import HighLight from "../HighLight";
import { Empty } from 'rlj-design';
import classNames from 'classnames';
import styles from "./index.less";

var SearchList = function SearchList(_ref) {
  var filterData = _ref.filterData,
      itemRender = _ref.itemRender,
      showSearch = _ref.showSearch,
      onChange = _ref.onChange,
      reset = _objectWithoutProperties(_ref, _excluded);

  var _useState = useState(''),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1]; // onChange事件，当前组件需要value值


  var handleChange = function handleChange(e) {
    var _e$target;

    setValue(e === null || e === void 0 ? void 0 : (_e$target = e.target) === null || _e$target === void 0 ? void 0 : _e$target.value);
    onChange === null || onChange === void 0 ? void 0 : onChange(e);
  }; // 当value存在显示搜索内容


  var listMemo = useMemo(function () {
    var _filter = (filterData || []).filter(function (i) {
      return i.label.includes(value);
    });

    return value && showSearch && /*#__PURE__*/React.createElement("div", {
      className: classNames(styles.list)
    }, _filter.map(function (item, index) {
      return /*#__PURE__*/React.createElement(Fragment, {
        key: index
      }, (itemRender === null || itemRender === void 0 ? void 0 : itemRender(item, styles.item)) || /*#__PURE__*/React.createElement("div", {
        onClick: function onClick() {
          var _item$onClick;

          return item === null || item === void 0 ? void 0 : (_item$onClick = item.onClick) === null || _item$onClick === void 0 ? void 0 : _item$onClick.call(item, item.value);
        },
        className: classNames(styles.item)
      }, /*#__PURE__*/React.createElement(HighLight, {
        highLightText: value
      }, item.label)));
    }), _filter.length === 0 && /*#__PURE__*/React.createElement(Empty, null));
  }, [value, showSearch, filterData]);
  return /*#__PURE__*/React.createElement("div", {
    className: styles.container
  }, /*#__PURE__*/React.createElement(CustomizeSearch, _extends({}, reset, {
    onChange: handleChange
  })), listMemo);
};

export default SearchList;